Global tacho=CreateTacho()

Function Game()
	Local player.player
	Local pl.player
	
	scroll_x=play\body\CenterX-GWIDTH/2
	scroll_y=play\body\CenterY-GHEIGHT/2
	TileBlock gras,-scroll_x,-scroll_y
	
	For y=0 To map_h-1
		For x=0 To map_w-1
			xx=(x*tile_size)-scroll_x
			yy=(y*tile_size)-scroll_y
			If xx+tile_size>0 And xx<GWIDTH And yy+tile_size>0 And yy<GHEIGHT Then
				If map(x,y)<>Null Then
					DrawBlock map(x,y)\img,xx,yy
				EndIf
			EndIf
		Next
	Next
	
	Local tabdown=KeyDown(15)
	For pl.player=Each player
		DrawImage pl\img[pl\w/3],pl\body\CenterX-scroll_x,pl\body\CenterY-scroll_y
		If tabdown Then
			BGText pl\body\CenterX-scroll_x,pl\body\CenterY-scroll_y,pl\name$,1,1
			BGText pl\body\CenterX-scroll_x,pl\body\CenterY-scroll_y+20,pl\config\car\name$+" ("+pl\config\installedups+")",1,1
		EndIf
	Next
	
	If play\totalwrong Then
		Color 255,0,0
		BGText 400,330,"Ungltige Runde!",1,1
	EndIf
	
	Color 255,255,255
	If play\wrong Then
		BGText 400,270,"Du fhrst falsch!",1,1
	EndIf
	
	ok=True
	If game_countdown<>-1 Then
		If global_time-game_countdown<3000 Then
			SetFont font_big
			BGText 400,300,(3-(global_time-game_countdown)/1000),1,1,True
			SetFont font_normal
			ok=False
		Else
			StartConditions()
			game_countdown=-1
		EndIf
	EndIf
	
	If ok Then
		For player=Each player
			ControlPlayer(player)
		Next
		
		UpdateEntities()
		
		PlayerRanking()
		
		;HUD
		DrawImage tacho,GWIDTH-100,GHEIGHT-124
		Text GWIDTH-50,GHEIGHT-12,Int(play\speed*20)+"km/h",1,1
		w=Abs(play\speed/play\maxspeed)*90
		Line GWIDTH,GHEIGHT-24,GWIDTH-Cos(w)*100,GHEIGHT-24-Sin(w)*100
		
		Color 0,0,0
		Rect 0,0,170,100,1
		Rect GWIDTH-110,0,150,game_playercount*20+20,1
		
		Local rank
		Local index=0
		For rank=1 To game_playercount
			For player=Each player
				If player\rank=rank Then
					ranking(index)=player
					Color player\config\r,player\config\g,player\config\b
					Text GWIDTH-100,10+index*20,player\name$
					index=index+1
				EndIf
			Next
		Next
		
		Color 255,255,255
		Text 10,10,"Runde: "+play\lap+" / "+game_lapstorace
		txt$=(global_time-game_starttime)/1000.0
		Text 10,30,"Gesamtzeit: "+Left(txt$,Len(txt$)-1)
		txt$=(global_time-play\lap_timer)/1000.0
		Text 10,50,"Rundenzeit: "+Left(txt$,Len(txt$)-1)
		If play\best_lap=2^16 Then
			Text 10,70,"Rundenrekord: ---"
		Else
			Text 10,70,"Rundenrekord: "+play\best_lap
		EndIf
	EndIf
	
End Function

Function CreatePlayer.player(config.carconfig,x,y,winkel)
	Local player.player=New player
	
	player\config=config
	player\body=CopyPhysEntity(config\car\body)
	player\w=winkel
	
	player\maxspeed=config\car\maxspeed
	player\acc=config\car\a
	player\brake=config\car\brake
	player\wspeed=config\car\wspeed
	player\handling=config\car\handling
	
	For i=0 To config\installedups-1
		player\maxspeed=player\maxspeed+config\car\maxspeed*(config\upgrades[i]\up[0]/100.0)
		player\acc=player\acc+config\car\a*(config\upgrades[i]\up[1]/100.0)
		player\brake=player\brake+config\car\brake*(config\upgrades[i]\up[2]/100.0)
		player\wspeed=player\wspeed+config\car\wspeed*(config\upgrades[i]\up[3]/100.0)
		player\handling=player\handling-config\car\handling*(config\upgrades[i]\up[4]/100.0)
	Next
	
	PositionPhysEntity(player\body,x,y)
	
	CreateCar(config)
	player\img[0]=config\preview
	For i=1 To 120
		player\img[i]=CopyImage(player\img[0])
		RotateImage(player\img[i],-i*3)
	Next
	
	Return player
End Function

Function ControlPlayer(player.player)
	Local a#=0
	Local impuls#
	Local dircheck,dir
	
	;Position auf Tiles abfragen -> Kontrolle ob Vorwrts oder Rckwrts gefahren
	player\curtilex=Floor(player\body\CenterX/tile_size)
	player\curtiley=Floor(player\body\CenterY/tile_size)
	Local dx=player\curtilex-player\oldtilex
	Local dy=player\curtiley-player\oldtiley
	If dx<0 Then dir=DIR_LEFT
	If dx>0 Then dir=DIR_RIGHT
	If dy<0 Then dir=DIR_UP
	If dy>0 Then dir=DIR_DOWN
	Local other=OtherDirection(dir)
	
	Local curtile.tile=map(player\curtilex,player\curtiley)
	If dx<>0 Or dy<>0 Then
		player\bot_timer=global_time
		
		If (Not player\totalwrong) And player\wrong=0 Then
			player\tilecount=player\tilecount+1
		EndIf
		
		;Richtungsberprfung ob man falsch oder richtig fhrt muss aufgeteilt werden,
		;da sie sich sonst mit der Runden-Abfrage "ins Gehege" kommt
		dircheck=True
		If other=player\expecteddir Then
			If player\wrong=0 Then
				player\wrong=1
				dircheck=False
			EndIf
		ElseIf dir=player\expecteddir Then
			
		ElseIf other=OtherDirection(ComplementDirection(player\expecteddir,map(player\oldtilex,player\oldtiley))) Then
			If player\wrong=0 Then
				player\wrong=1
				dircheck=False
			EndIf
		Else
			player\totalwrong=True
			dircheck=False
		EndIf
		
		If player\curtilex=map_start_x And player\curtiley=map_start_y Then
			If (Not player\totalwrong) And player\wrong=0 Then
				ok=True
				If player<>play Then
					If dir<>curtile\dir1[1] Then
						ok=False
						player\wrong=1
						dircheck=False
					EndIf
				EndIf
				
				If ok Then
					If (global_time-player\lap_timer)/1000.0<player\best_lap Then
						player\best_lap=(global_time-player\lap_timer)/1000.0
					EndIf
					player\lap_timer=global_time
					player\lap=player\lap+1
					player\tilecount=0
					
					If player\lap>game_lapstorace Then
						QuitGame(player)
					EndIf
				EndIf
			Else
				player\totalwrong=False
				If curtile\dir1[1]=other Then
					player\wrong=1
				EndIf
			EndIf
		EndIf
		
		If dircheck Then
			If other=player\expecteddir Then
				If player\wrong<>0 Then
					player\wrong=-player\wrong+1
				EndIf
			ElseIf dir=player\expecteddir Then
				If player\wrong<>0 Then player\wrong=player\wrong+1
			ElseIf other=OtherDirection(ComplementDirection(player\expecteddir,map(player\oldtilex,player\oldtiley))) Then
				If player\wrong<>0 Then
					player\wrong=-player\wrong+1
				EndIf
			EndIf
		EndIf
		
		player\expecteddir=ComplementDirection(other,curtile)
	EndIf
	
	;Physikalisch komplett schwachsinnige Winkelkorrektur
	If player\body\AngularV<>0 Then
		player\body\Omega#=player\body\Omega#+RadToDeg(player\body\AngularV#)*4
		player\body\AngularV=0
	EndIf
	
	;Kollision entdecken und dementsprechend Geschw. drosseln
	Local vx#=player\speed*Cos(player\w)
	Local vy#=player\speed*Sin(player\w)
	
	If player\body\Collided Then
		impuls=Sqr((vx-player\body\VX)*(vx-player\body\VX)+(vy+player\body\VY)*(vy+player\body\VY))
		a=a-impuls*0.1
	EndIf
	;und in der Physikegine rum pfuschen...
	player\body\VX=0
	player\body\VY=0
	
	player\w=(player\body\Omega+360) Mod 360
	
	Local w_diff#
	Local targetw
	If play=player Then
		;Spieler-Steuerung
		If KeyDown(200) Then
			a=a+(player\maxspeed-player\speed)*player\acc
		Else
			If player\speed>0 Then
				a=a-(player\maxspeed)*0.001
			EndIf
		EndIf
		
		If KeyDown(208) Then
			a=a-(player\maxspeed-player\speed+1)*player\brake
			If player\speed=0 Then
				If player\reverse_timer=0 Then
					player\reverse_timer=global_time
				EndIf
			EndIf
		Else
			player\reverse_timer=0
		EndIf
		
		w_diff#=(KeyDown(203)-KeyDown(205))*player\wspeed
		
	Else
		;Bot-Steuerung
		If global_time-player\bot_timer>3000 Then
			player\bot_timer=global_time
			player\bot_corr=global_time
			PositionPhysEntity(player\body,player\curtilex*tile_size+tile_size/2,player\curtiley*tile_size+tile_size/2)
		EndIf
		
		If global_time-player\bot_corr>1000 Then
			a=a+(player\maxspeed-player\speed)*player\acc
			player\bot_corr=0
		Else
			player\speed=0
		EndIf
		
		If player\wrong Then
			If player\bot_corr=0 Then player\w=player\w+180
			player\bot_corr=global_time
			player\wrong=False ;ACHTUNG!
		Else
			Select player\expecteddir
				Case DIR_DOWN
					targetw=270
				Case DIR_UP
					targetw=90
				Case DIR_LEFT
					targetw=180
				Case DIR_RIGHT
					targetw=0
			End Select
		EndIf
		
		If Abs(targetw-player\w)>player\wspeed Then
			If player\w<targetw Then
				If Abs(player\w-targetw)<180 Then
					w_diff#=player\wspeed
				Else
					w_diff#=-player\wspeed
				EndIf
			EndIf
			If player\w>targetw Then
				If Abs(targetw-player\w)<180 Then
					w_diff#=-player\wspeed
				Else
					w_diff#=player\wspeed
				EndIf
			EndIf
		EndIf
	EndIf
	
	If player\speed<player\maxspeed/3 Then
		w_diff=w_diff*(player\speed/(player\maxspeed/3))
	EndIf
	player\w=player\w+w_diff
	player\w=(player\w+360) Mod 360
	player\body\Omega=player\w
	If w_diff<>0 Then
		a=a-(player\maxspeed)*player\handling
	EndIf
	
	player\speed=player\speed+a
	If player\reverse_timer=0 Then
		If player\speed<0.1 Then player\speed=0
	Else
		If global_time-player\reverse_timer>250 Then
			If player\speed<-player\maxspeed/4 Then player\speed=-player\maxspeed/4
		Else
			If player\speed<0.1 Then player\speed=0
		EndIf
	EndIf
	
	AddForce(player\body,player\body\CenterX,player\body\CenterY,player\speed*Cos(player\w),-player\speed*Sin(player\w))
	
	player\oldtilex=player\curtilex
	player\oldtiley=player\curtiley
End Function

Function QuitGame(player.player)
	Local high.highscore
	
	SetFont font_big
	Local h=40
	Local ok=True
	;Rundenrekord?
	If play\best_lap<2^16 Then
		For high=Each highscore
			If high\track$=menu_seltrack\name$ Then
				If high\time<play\best_lap Then
					ok=False
					Exit
				EndIf
			EndIf
		Next
		If ok Then h=h+30
		
		NewHighscore()
		SaveHighscore()
	Else
		ok=False
	EndIf
	
	;Gewinnen / Verlieren / Karrierekram
	Local money=0
	If player=play Then
		If racemode=RACE_CAREER Then
			h=h+30
			money=(game_lapstorace*500)+(game_playercount*500)
			game_money=game_money+money
			game_racewins=game_racewins+1
		EndIf
		txt$="Du hast gewonnen!"
	Else
		If racemode=RACE_CAREER Then
			game_racenowin=game_racenowin+1
		EndIf
		If play\rank=1 Then play\rank=2
		txt$="Leider nur "+play\rank+"."
	EndIf
	SavePlayerConfig()
	
	Color 0,0,0
	Rect GWIDTH/2-200,GHEIGHT/2-h/2,400,h,1
	Color 255,255,255
	Text 400,GHEIGHT/2-h/2+5,txt$,1
	SetFont font_normal
	
	Local y=GHEIGHT/2-h/2+40
	If ok Then
		Text 400,y,play\best_lap+" ist neuer Streckenrekord!",1
		y=y+30
	EndIf
	
	If money<>0 Then
		Text 400,y,"Du hast "+money+Chr(128)+" gewonnen!",1
	EndIf
	
	Flip 0:Delay 1000
	BGText(GWIDTH/2,GHEIGHT/2+h/2,"Bitte Taste drcken",1,0)
	Flip 0
	FlushKeys():WaitKey()
	FlushKeys():FlushMouse()
	gamemode=MODE_MENU
End Function

Function OtherDirection(dir)
	If dir=DIR_UP Then Return DIR_DOWN
	If dir=DIR_DOWN Then Return DIR_UP
	If dir=DIR_RIGHT Then Return DIR_LEFT
	If dir=DIR_LEFT Then Return DIR_RIGHT
End Function

Function ComplementDirection(dir,tile.tile)
	If dir=tile\dir1[0] Then Return tile\dir1[1]
	If dir=tile\dir1[1] Then Return tile\dir1[0]
	If dir=tile\dir2[0] Then Return tile\dir2[1]
	If dir=tile\dir2[1] Then Return tile\dir2[0]
End Function

Function CreateTrackImages()
	asphalt=CreateImage(zoom,zoom)
	SetBuffer ImageBuffer(asphalt)
	For x=0 To zoom-1
		For y=0 To zoom-1
			c=Rand(160,180)
			WritePixel x,y,c Shl 16+c Shl 8+c
		Next
	Next
	
	gras=CreateImage(zoom,zoom)
	SetBuffer ImageBuffer(gras)
	For x=0 To zoom-1
		For y=0 To zoom-1
			c=Rand(120,150)
			WritePixel x,y,c Shl 8
		Next
	Next
	
	SetBuffer BackBuffer()
End Function

Function CreateTacho(size=100)
	Local img=CreateImage(size,size)
	SetBuffer ImageBuffer(img)
	
	Color 200,0,0
	For w=0 To 90 Step 5
		Line size-Cos(w)*size,size-Sin(w)*size,size,size
	Next
	Oval 0,0,size*2,size*2,0
	Color 0,0,0
	Oval size/10,size/10,2*size-2*(size/10),2*size-2*(size/10),1
	
	Local img2=CreateImage(size,size+24)
	SetBuffer ImageBuffer(img2)
	Color 1,1,1
	Oval 0,0,size*2,size*2,1
	Rect 0,size,size,24,1
	Color 200,0,0
	Rect 0,size,size,24,0
	DrawImage img,0,0
	SetBuffer BackBuffer()
	
	FreeImage img
	Return img2
End Function

Function LoadMap(file$)
	Local tile.tile
	If Left(file$,6)<>"tracks\" Then file$="tracks\"+file$
	If Right(file$,4)<>".dat" Then file$=file$+".dat"
	Local reader=ReadFile(file$)
	If reader=0 Then RuntimeError(file$+" nicht gefunden")
	
	map_w=ReadByte(reader)
	map_h=ReadByte(reader)
	map_start_x=ReadByte(reader)
	map_start_y=ReadByte(reader)
	Dim map(map_w,map_h)
	
	Local E.TEntity
	While Not Eof(reader)
		For y=0 To map_h-1
			For x=0 To map_w-1
				temp=ReadByte(reader)
				If temp<>-1 Then
					For tile=Each tile
						If tile\id=temp Then
							map(x,y)=tile
							i=0
							While tile\PhysEntity[i]<>Null
								E=New TEntity
								For j=0 To 2
									xx=tile\PhysEntity[i]\Vertex[j]\GlobalX
									yy=tile\PhysEntity[i]\Vertex[j]\GlobalY
									CreateVertex(E,xx+x*tile_size,yy+y*tile_size,1)
								Next
								E\Locked=True
								InitEntity E
								i=i+1
							Wend
							Exit
						EndIf
					Next
				EndIf
			Next
		Next
	Wend
	
	CloseFile reader
End Function

Function LoadTiles()
	Local dir=ReadDir("tiles")
	Local file$
	Local tile.tile
	Local reader
	Local EntityCount
	Local byte
	Repeat
		file$=NextFile(dir)
		If file$="" Then Exit
		If Right(file$,4)=".dat" Then
			tile=New tile
			tile\id=Left(file$,Instr(file$,".")-1)
			EntityCount=0
			
			Local temp=CreateImage(tile_size,tile_size)
			SetBuffer ImageBuffer(temp)
			;Strae
			TileBlock asphalt
			
			reader=ReadFile("tiles\"+file$)
			
			byte=ReadByte(reader)
			
			k=0
			For j=0 To 3
				If (byte And (1 Shl j))/2^j Then
					tile\dir1[k]=j+1
					k=k+1
				EndIf
			Next
			k=0
			For j=4 To 7
				If (byte And (1 Shl j))/2^j Then
					tile\dir2[k]=j-3
					k=k+1
				EndIf
			Next
			
			For k=0 To 1
				If k=0 Then
					Color 0,0,0
				Else
					Color 200,150,0
				EndIf
				
				count=ReadByte(reader)
				For j=1 To count
					
					x0=ReadByte(reader)*zoom
					y0=ReadByte(reader)*zoom
					x1=ReadByte(reader)*zoom
					y1=ReadByte(reader)*zoom
					x2=ReadByte(reader)*zoom
					y2=ReadByte(reader)*zoom
					
					If k=0 Then
						
						Line x0,y0,x1,y1
						Line x2,y2,x1,y1
						Line x0,y0,x2,y2
						filltri(x0,y0,x1,y1,x2,y2)
						
						tile\PhysEntity[EntityCount]=New TEntity
						CreateVertex(tile\PhysEntity[EntityCount],x0,y0,1)
						CreateVertex(tile\PhysEntity[EntityCount],x1,y1,1)
						CreateVertex(tile\PhysEntity[EntityCount],x2,y2,1)
						tile\PhysEntity[EntityCount]\Locked=True
						InitEntity tile\PhysEntity[EntityCount]
						tile\PhysEntity[EntityCount]\Deactivate=True
						
						EntityCount=EntityCount+1
					Else
						;Begrenzungszaun
						xn=(x0+x1+x2)/3
						yn=(y0+y1+y2)/3
						dy=y2-yn
						dx=x2-xn
						
						Color 150,100,0
						For i#=1 To 3 Step 0.25
							Line x0+dx*i*0.03,y0+dy*i*0.03,x1+dx*i*0.03,y1+dy*i*0.03
						Next
						
						Color 100,50,0
						Oval x0-3+dx*0.1,y0-3+dy*0.1,6,6,1
						Oval x1-3+dx*0.1,y1-3+dy*0.1,6,6,1
						
					EndIf
				Next
			Next
			
			;Image auf Gras abbilden
			tile\img=CreateImage(tile_size,tile_size)
			SetBuffer ImageBuffer(tile\img)
			TileBlock gras
			DrawImage temp,0,0
			SetBuffer BackBuffer()
			
			FreeImage temp
			tile\prev=CopyImage(tile\img)
			ResizeImage(tile\prev,50,50)
			
			CloseFile reader
			
			SetBuffer BackBuffer()
			tile\prev=CopyImage(tile\img)
			ResizeImage(tile\prev,50,50)
			
		EndIf
	Forever
	CloseDir dir
End Function

Function CreateCar(config.carconfig)
	config\preview=CopyImage(config\car\img)
	Local w=ImageWidth(config\preview)-1
	Local h=ImageHeight(config\preview)-1
	If config\selpaint<>0 Then
		Local buff=ImageBuffer(config\car\paints[config\selpaint-1])
	EndIf
	
	SetBuffer ImageBuffer(config\preview)
	LockBuffer
	LockBuffer buff
	
	Local r#=config\r/255.0
	Local g#=config\g/255.0
	Local b#=config\b/255.0
	Local pr#=config\pr/255.0
	Local pg#=config\pg/255.0
	Local pb#=config\pb/255.0
	
	For x=0 To w
		For y=0 To h
			If config\selpaint<>0 Then
				c=ReadPixelFast(x,y,buff)
				cb=c And $FF
				If cb<>0 Then
					cr=(c And $FF0000)/$10000
					cg=(c And $FF00)/$100
					cr=CarColor(cr,pr)
					cg=CarColor(cg,pg)
					cb=CarColor(cb,pb)
					flag=False
				Else
					flag=True
				EndIf
			Else
				flag=True
			EndIf
			
			If flag Then
				c=ReadPixelFast(x,y)
				cr=(c And $FF0000)/$10000
				cg=(c And $FF00)/$100
				cb=c And $FF
				cr=CarColor(cr,r)
				cg=CarColor(cg,g)
				cb=CarColor(cb,b)
			EndIf
			
			WritePixelFast(x,y,cr Shl 16+cg Shl 8+cb)
		Next
	Next
	
	UnlockBuffer buff
	UnlockBuffer
	
	SetBuffer BackBuffer()
	MidHandle config\preview
End Function

Function CarColor(c,val#)
	If c=5 Then
		Return 1
	Else
		Return c*val
	EndIf
End Function

Function StartGame()
	Local player.player
	For player=Each player
		For i=0 To 120
			FreeImage player\img[i]
		Next
		RemoveEntity(player\body)
		Delete player
	Next
	Local config.carconfig
	For config=Each carconfig
		If config\bot Then Delete config
	Next
	
	Local car.car
	Local carcount=0
	For car=Each car
		carcount=carcount+1
	Next
	
	Local Entity.TEntity
	
	Local tile.tile
	For Entity=Each TEntity
		ok=True
		For car=Each car
			If Entity=car\body Then
				ok=False
				Exit
			EndIf
		Next
		If ok Then
			For tile=Each tile
				For i=0 To 31
					If tile\PhysEntity[i]=Null Then Exit
					If Entity=tile\PhysEntity[i] Then
						ok=False
						Exit
					EndIf
				Next
				If Not ok Then Exit
			Next
		EndIf
		If ok Then RemoveEntity(Entity)
	Next
	
	Cls
	BGText(GWIDTH/2,GHEIGHT/2-30,"Lade Karte: "+menu_seltrack\name$,1,1)
	LoadMap(menu_seltrack\name$)
	
	tile.tile=map(map_start_x,map_start_y)
	If tile\dir1[1]=DIR_RIGHT Then
		w=0
	ElseIf tile\dir1[1]=DIR_DOWN Then
		w=270
	EndIf
	
	Dim startpos(5,1)
	Restore startposition
	For i=0 To 5
		If w=270 Then
			Read startpos(i,0)
			Read startpos(i,1)
		ElseIf w=0 Then
			Read startpos(i,1)
			Read startpos(i,0)
		EndIf
	Next
	
	StatusMessage("Lade Spieler...",False)
	play=CreatePlayer(pl_config,map_start_x*tile_size+tile_size/2+startpos(0,0),map_start_y*tile_size+tile_size/2+startpos(0,1),w)
	play\name$=game_playername$
	
	Local botconfig.carconfig
	Local up.upgrade
	For i=1 To game_playercount-1
		botconfig=New carconfig
		botconfig\r=Rand(0,255)
		botconfig\g=Rand(0,255)
		botconfig\b=Rand(0,255)
		Repeat
			botconfig\pr=Rand(0,255)
			botconfig\pg=Rand(0,255)
			botconfig\pb=Rand(0,255)
		Until Abs((botconfig\r+botconfig\g+botconfig\b)-(botconfig\pr+botconfig\pg+botconfig\pb))>50
		botconfig\bot=True
		
		Repeat
			num=Rand(1,carcount)
			car=First car
			For j=1 To num-1
				car=After car
			Next
		Until car\maxspeed<=play\maxspeed
			
		botconfig\car=car
		
		For j=0 To 8
			If car\paints[j]=0 Then Exit
		Next
		botconfig\selpaint=Rand(0,j)
		
		up=Last upgrade
		While up<>Null
			If up\car=car Then
				If game_racewins>=up\neededWins Then
					If Rand(0,1)=0 Then
						ok=True
						For j=0 To botconfig\installedups-1
							If botconfig\upgrades[j]\group=up\group Then
								ok=False
								Exit
							EndIf
						Next
						If ok Then
							botconfig\upgrades[botconfig\installedups]=up
							botconfig\installedups=botconfig\installedups+1
						EndIf
					EndIf
				EndIf
			EndIf
			up=Before up
		Wend
		
		CreateCar(botconfig)
	Next
	
	i=1
	For config=Each carconfig
		If config\bot Then
			StatusMessage("Lade Gegner "+i+"...",False)
			bot.player=CreatePlayer(config,map_start_x*tile_size+tile_size/2+startpos(i,0),map_start_y*tile_size+tile_size/2+startpos(i,1),w)
			bot\name$="Bot "+i
			i=i+1
		EndIf
	Next
End Function

Function StartConditions()
	Local pl.player
	Local tile.tile
	For pl.player=Each player
		pl\body\Omega=pl\w
		pl\best_lap=2^16
		pl\lap_timer=global_time
		pl\bot_timer=global_time
		pl\bot_corr=0
		pl\tilecount=0
		pl\lap=1
		pl\tilecount=0
		pl\speed=0
		pl\wrong=0
		pl\totalwrong=False
		pl\curtilex=Floor(pl\body\CenterX/tile_size)
		pl\curtiley=Floor(pl\body\CenterY/tile_size)
		pl\oldtilex=pl\curtilex
		pl\oldtiley=pl\curtiley
		tile.tile=map(pl\curtilex,pl\curtiley)
		pl\expecteddir=tile\dir1[1]
	Next
	game_starttime=global_time
End Function

Function PlayerRanking()
	Local player.player
	Local pl.player
	
	For player=Each player
		player\rank=1
		For pl=Each player
			If pl<>player Then
				If pl\lap>player\lap Then
					player\rank=player\rank+1
				ElseIf pl\lap=player\lap Then
					If pl\tilecount>player\tilecount Then
						player\rank=player\rank+1
					EndIf
				EndIf
			EndIf
		Next
	Next
End Function

Function LoadHighscore()
	Local reader=ReadFile("highscore.dat")
	Local high.highscore
	If reader<>0 Then
		While Not Eof(reader)
			high=New highscore
			high\track$=ReadString(reader)
			high\player$=ReadString(reader)
			high\car$=ReadString(reader)
			high\time=ReadFloat(reader)
		Wend
		CloseFile reader
	EndIf
End Function

Function SaveHighscore()
	Local writer=WriteFile("highscore.dat")
	Local high.highscore
	For high=Each highscore
		WriteString writer,high\track$
		WriteString writer,high\player$
		WriteString writer,high\car$
		WriteFloat writer,high\time
	Next
	CloseFile writer
End Function

Function PrepareHighscore()
	Local high.highscore
	i=0
	For high=Each highscore
		high\id=i
		i=i+1
	Next
	
	;Sortieren nach Zeit (Filterung nach Strecke bei ShowHighscore)
	Local high2.highscore,high3.highscore
	For high=Each highscore
		high2=After high
		If high2<>Null Then 
			If high2\time<high\time
				For high3=Each highscore
					If high2\time<high3\time Then 
						Insert high2 Before high3 
						high=Before high
						Exit 
					EndIf 
				Next 
			EndIf 
		EndIf 
	Next
	
	;Nur die besten 15 behalten
	Local track.track
	Local count
	For track=Each track
		count=0
		For high=Each highscore
			If high\track$=track\name$ Then
				If count>14 Then Delete high
				count=count+1
			EndIf
		Next
	Next
	
	SaveHighscore()
End Function

Function ShowHighscore()
	
	If MenuButton(10,GHEIGHT-50,190,40,"Zurck") Then
		gamemode=MODE_MENU
	EndIf
	
	Text 105,10,"Verfgbare Strecken",1
	Rect 5,5,200,GHEIGHT-65,0
	
	Local track.track
	x=10
	y=30
	h=20
	w=190
	For track=Each track
		Text x,y+10,Left(track\name$,Len(track\name$)-4)
		
		If RectButton(x,y+h/2,w,h) Then
			menu_seltrack=track
		EndIf
		
		If menu_seltrack=track Then Rect x-2,y+h/2-2,w+4,h+4,0
		
		y=y+20
	Next
	
	Text 415,10,"Rundenbestzeiten",1
	Rect 210,5,400,GHEIGHT-65,0
	
	If menu_seltrack<>Null Then
		Local high.highscore
		x=215
		y=30
		Text x,y+10,"Spielername"
		Text x+130,y+10,"Auto (Upgrades)"
		Text x+300,y+10,"Zeit (sek)"
		y=y+30
		For high=Each highscore
			If high\track$=menu_seltrack\name$ Then
				Text x,y+10,high\player$
				Text x+130,y+10,high\car$
				Text x+300,y+10,high\time
				
				y=y+20
			EndIf
		Next
	EndIf
End Function

Function NewHighscore()
	If play\best_lap=2^16 Then Return
	Local high.highscore=New highscore
	high\track$=menu_seltrack\name$
	high\player=play\name$
	high\time=play\best_lap
	high\car$=play\config\car\name$+" ("+play\config\installedups+")"
End Function


;~IDEal Editor Parameters:
;~F#2#65#86#15C#19F#1A6#1AD#1C3#1DD#20A#27C#2B7#2BF#349#362#376#385#391#3BA#3EB
;~C#Blitz3D