Const GWIDTH=800
Const GHEIGHT=600
Graphics GWIDTH,GHEIGHT,0,2
SetBuffer BackBuffer()

Global font_normal=LoadFont("Arial",18)
Global font_big=LoadFont("Arial Black",28)
SetFont font_normal

TFormFilter 0
AppTitle "BCC33 - Rock me Amadeus v1.0"
SeedRnd MilliSecs()

Type tile
	Field id
	Field img
	Field prev
	Field PhysEntity.TEntity[32]
	Field dir1[1]
	Field dir2[1]
End Type

Const DIR_UP=1
Const DIR_LEFT=2
Const DIR_RIGHT=3
Const DIR_DOWN=4

Global zoom=20
Global tile_size=14*zoom
Global scroll_x,scroll_y

Global game_starttime
Global game_countdown
Global game_racewins
Global game_racenowin
Global game_money=40000
Global game_playercount
Global game_pause_time
Global game_playername$="Spieler"
Global game_lapstorace

Global global_time

Global map_w=5
Global map_h=5
Global map_start_x=-1
Global map_start_y
Dim map.tile(map_w,map_h)

Dim startpos(5,1)

Const MODE_MENU=0
Const MODE_GAME=1
Const MODE_EDIT=2
Const MODE_GARAGE=3
Const MODE_TUNING=4
Const MODE_SHOP=5
Const MODE_TRACK=6
Const MODE_EDITORLOAD=7
Const MODE_GAME_PAUSE=8
Const MODE_HIGH=9
Global gamemode=MODE_MENU

Const RACE_FREE=1
Const RACE_CAREER=2
Global racemode

Global ctrl_mhit,ctrl_mhit2,ctrl_mx,ctrl_my

Local gametimer=CreateTimer(50)
Local menutimer=CreateTimer(30)

Type player
	Field img[121]
	Field body.TEntity
	Field config.carconfig
	Field w#
	Field speed#
	Field maxspeed#
	Field acc#
	Field brake#
	Field wspeed#,handling#
	Field reverse_timer
	Field oldtilex,oldtiley
	Field curtilex,curtiley
	Field expecteddir
	Field wrong,totalwrong
	Field lap
	Field lap_timer
	Field best_lap#
	Field bot_timer
	Field bot_corr
	Field rank
	Field tilecount
	Field name$
End Type
Global play.player
Dim ranking.player(5)

Type car
	Field name$
	Field img
	Field body.TEntity
	Field maxspeed#
	Field a#,brake#
	Field wspeed#,handling#
	Field paints[8]
	Field kosten
End Type

Type upgrade
	Field car.car
	Field group$
	Field name$
	Field kosten
	Field neededWins
	Field up[4]
End Type

Type carconfig
	Field car.car
	Field r,g,b
	Field selpaint
	Field pr,pg,pb
	Field upgrades.upgrade[20]
	Field installedups
	Field preview
	Field bot
	Field amadeus
End Type
Global pl_config.carconfig

Type track
	Field name$
	Field preview
End Type

Type highscore
	Field track$
	Field player$
	Field car$
	Field time#
	Field id
End Type

Type particle
	Field x#,y#
	Field vx#,vy#
	Field lifes
	Field col
End Type

StatusMessage("Erstelle Graphiken...")
Global asphalt,gras
CreateTrackImages()
LoadTiles()

StatusMessage("Verfgbare Autos erfassen...")
LoadCars()

If Not LoadPlayerConfig() Then
	Cls
	Locate 10,10
	game_playername$=Input("Bitte Namen deines Spielers eingeben: ")
	SavePlayerConfig()
EndIf
LoadHighscore()

pl_config=First carconfig
Repeat
	If pl_config=Null Then Exit
	If Not pl_config\bot Then Exit
	pl_config=After pl_config
Forever
isAmadeus(pl_config)

Include "Physik.bb"
Include "TrackEditor.bb"
Include "Menu.bb"
Include "Game.bb"

Repeat
	global_time=MilliSecs()
	If KeyHit(1) Then
		If gamemode=MODE_GAME Then
			gamemode=MODE_GAME_PAUSE
			game_pause_time=global_time
			FlushMouse()
		ElseIf gamemode=MODE_GAME_PAUSE Then
			gamemode=MODE_GAME
		ElseIf gamemode=MODE_MENU Then
			Exit
		Else
			gamemode=MODE_MENU
		EndIf
	EndIf
	
	If gamemode<>MODE_GAME_PAUSE Then
		Cls
		If gamemode<>MODE_GAME Then
			MouseInput()
			Color 255,255,255
		EndIf
	EndIf
	
	Select gamemode
		Case MODE_MENU
			Menu()
		Case MODE_GAME
			Game()
		Case MODE_EDIT
			Editor()
		Case MODE_GARAGE
			Garage()
		Case MODE_TUNING
			Tuning()
		Case MODE_SHOP
			CarShop()
		Case MODE_TRACK
			Trackmenu(True)
		Case MODE_EDITORLOAD
			Trackmenu(False)
		Case MODE_GAME_PAUSE
			GameMenu()
		Case MODE_HIGH
			ShowHighscore()
	End Select
	
	Flip 0
	If gamemode=MODE_GAME Then
		WaitTimer gametimer
	Else
		WaitTimer menutimer
	EndIf
Forever
End

;Hilfsfunkt
Function MouseInput()
	ctrl_mx=MouseX()
	ctrl_my=MouseY()
	ctrl_mhit=MouseHit(1)
	ctrl_mhit2=MouseHit(2)
End Function

Function StatusMessage(txt$,clear=True)
	If clear Then Cls
	BGText(GWIDTH/2,GHEIGHT/2,txt$,1,1)
	Flip 0
End Function

Function BGText(x,y,txt$,cx=0,cy=0,border=False)
	Color 0,0,0
	
	w=StringWidth(txt$)+4
	h=StringHeight(txt$)+4
	If cx Then
		rx=x-w/2
	Else
		rx=x-2
	EndIf
	If cy Then
		ry=y-h/2
	Else
		ry=y-2
	EndIf
	
	Rect rx,ry,w,h,1
	Color 255,255,255
	Text x,y,txt$,cx,cy
	If border Then
		Rect rx,ry,w,h,0
	EndIf
End Function

;von Triton
Function filltri(x1,y1,x2,y2,x3,y3)
	Local p,q
	Local m13#,n13#,m12#,n12#,m23#,n23#
	Local by1#,by2#,by3#,by4#
	Local bx#
	For oft=0 To 1
		If x1>x2 Then
			p=x2
			x2=x1
			x1=p 
			q=y2
			y2=y1
			y1=q
		End If
		If x1>x3 Then
			p=x3
			x3=x1
			x1=p
			q=y3
			y3=y1
			y1=q
		End If
		If x2>x3 Then
			p=x3
			x3=x2
			x2=p
			q=y3
			y3=y2
			y2=q
		End If
	Next
	
	For bx#=x1 To x2
		m13#=(Float(y3-y1)/(x3-x1))
		n13#=-m13*x1+y1
		by1#=m13*bx+n13
		
		m12#=(Float(y2-y1)/(x2-x1))
		n12#=-m12*x1+y1
		by2#=m12*bx+n12
		If by2-by1>0 Then Rect bx,by1,1,by2-by1
		If by2-by1<0 Then Rect bx,by2,1,by1-by2
	Next
	For bx=x2 To x3
		m13#=(Float(y3-y1)/(x3-x1))
		n13#=-m13*x3+y3
		by3#=m13*bx+n13
		
		m23#=(Float(y3-y2)/(x3-x2))
		n23#=-m23*x2+y2
		by4#=m23*bx+n23
		If by4-by3>0 Then Rect bx,by3,1,by4-by3
		If by4-by3<0 Then Rect bx,by4,1,by3-by4
	Next
End Function

.startposition
Data 10,0
Data -20,-80
Data -50,0
Data 40,-80
Data 70,0
Data -80,-80
;~IDEal Editor Parameters:
;~F#48#63#6E#77#84#89#91#EE#FB#114
;~C#Blitz3D